/****************************************************************************************/
/*** modification story                                                           *******/
/****************************************************************************************/ 
/*	driver.c																			*/
/*																						*/
/****************************************************************************************/ 

//********* include ***********
#include "MyTypes.h"
#include "myglobals.h"

#include <conio.h>
#include <string.h>


#include <windows.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <winioctl.h>
#include "gpioctl.h"        // This defines the IOCTL constants.


//***************************************************************************//
//*																			*//
//*                         Parallel Port access							*//
//*																			*//
//***************************************************************************//
// Internal Function : 
// OpenIOPort:	Open Driver to access hardware under Windows NT
// returns : COK: normal execution
//			OPEN_DRIVER_READ_ERR
//*****************************************************************************//
int OpenParPort(void)
{

	hndFile = CreateFile(
                "\\\\.\\LPTPARIO1",                    // Open the Device "file"
                GENERIC_READ|GENERIC_WRITE,
                0,
                NULL,
                OPEN_EXISTING ,						//0x03
                FILE_ATTRIBUTE_NORMAL,				//0x80
                NULL
                );

    if (hndFile == INVALID_HANDLE_VALUE)        // Was the device opened?
    {
        //printf("Unable to open the device.\n");
		Erreur=GetLastError();
        return (OPEN_DRIVER_READ_ERR);
    }

	return COK;
}

/*****************************************************************************
// Internal Function : 
// OpenIOPort:	Open Driver to access hardware under Windows NT
// returns : COK: normal execution
//			WRITE_ERROR		: close error: see getlasterror
//*****************************************************************************/
int WriteParPort(unsigned char Data2Write)
{

	IoctlResult = DeviceIoControl
		(hndFile,                // Handle to device
		IOCTL_PARIO_WRITE_PORT_DATA,	// IO Control code for Write
		&Data2Write,					// Buffer to driver.
		1,								// Length of buffer in bytes.
		NULL,							// Buffer from driver.   Not used.
		0,								// Length of buffer in bytes.
		&ReturnedLength,				// Bytes placed in outbuf.  Should be 0.
		NULL							// NULL means wait till I/O completes.
		);			
	
	if (IoctlResult)                            // Did the IOCTL succeed?
    {
        return 0;
    }
    else
    {
		Erreur=GetLastError();
        return (WRITE_ERROR);
    }

}

/*****************************************************************************
// Internal Function : 
// OpenIOPort:	Open Driver to access hardware under Windows NT
// returns : COK: normal execution
//			 CNOK : READ error: see getlasterror
//*****************************************************************************/
unsigned char ReadParPort(void)
{

	unsigned char ReadData;

	IoctlResult = DeviceIoControl
		(hndFile,                // Handle to device
		IOCTL_PARIO_READ_PORT_STATUS,	// IO Control code for Write
		NULL,					// Buffer to driver.
		0,								// Length of buffer in bytes.
		&ReadData,							// Buffer from driver.
		1,								// Length of buffer in bytes.
		&ReturnedLength,				// Bytes placed in outbuf.  
		NULL							// NULL means wait till I/O completes.
		);	
	
	
	if (IoctlResult)                            // Did the IOCTL succeed?
    {
        return (ReadData);
    }
    else
    {
		Erreur=GetLastError();
        return (CNOK);
    }

}

/*****************************************************************************
// Internal Function : 
// OpenIOPort:	Open Driver to access hardware under Windows NT
// returns : COK: normal execution
//			CLOSE_DRIVER_ERR		: close error: see getlasterror
//*****************************************************************************/
int CloseParPort(void)
{


	if (!CloseHandle(hndFile))
	{                  // Close the Device "file".
        printf("Failed to close device.\n");
		Erreur=GetLastError();
		return (CLOSE_DRIVER_ERR);
    }

	return COK;

}
