/****************************************************************************************/
/*** modification story                                                           *******/
/****************************************************************************************/ 
/*	thermometre_DS1720.c																*/
/*																						*/
/* Pinout :																				*/
/*			D7/Error=Dq (bidirectionnal)												*/
/*			D6=#RST																		*/
/*			D5=Clk																		*/
/*																						*/
/****************************************************************************************/ 

//********* include ***********
#include "MyTypes.h"
#include "myglobals.h"
#include "thermometre_DS1720.h"
#include "driver.h"

#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include <dos.h>
#include <process.h>



//********* functions *********
//*****************************************************************************
// Internal Function : 
// init	:	init 
// returns : COK : normal execution
//*****************************************************************************
int RstThermo(void)
{
	if( WindowsVersion==isWindowsNT )	//->WinNT
	{
	
			ErreurDriverLevel=WriteParPort(0x00);	//rst on 
	//		Sleep(1);
			ErreurDriverLevel=WriteParPort(0x40);	//rst off
	//		Sleep(1);
		
		return COK;
	}
	else //->Win9x
	{
		return COK;
	}

}

//*****************************************************************************
// Internal Function : 
// init	:	init 
// returns : COK : normal execution
//*****************************************************************************
int SendControlThermo(int data2send)
{
	int control;
	int n;
	control=data2send;

	for(n=0;n<8;n++)
	{
		ErreurDriverLevel=WriteParPort(0xC0);	//clk off 
		if(control/2*2 == control)
		{
			ErreurDriverLevel=WriteParPort(0x40);	//low 
	//		Sleep(1);
			ErreurDriverLevel=WriteParPort(0x60);	//low + clock on 
		}

		else
		{
			ErreurDriverLevel=WriteParPort(0xc0);	//high 
	//		Sleep(1);
			ErreurDriverLevel=WriteParPort(0xe0);	//high + clock on 
		}

		control/=2;
		//Sleep(1);
	}
	return COK;
}

//*****************************************************************************
// Internal Function : read the current temperature
// returns : temperature
//*****************************************************************************
int  ReadThermo(void)
{
	int in, temp, k;
	
	RstThermo();
	SendControlThermo(0x0C); //write conf reg
	SendControlThermo(0x03);	//CLK & 1 shot
	RstThermo();
	SendControlThermo(0xEE);	//start convert
	SendControlThermo(0x00);	//stop convert (usefull in one shot ?)
	RstThermo();
	SendControlThermo(0xAA);
	ErreurDriverLevel=WriteParPort(0xC0);	//data high+rst high
	in=0;
	for (k=0;k<9;k++)
	{
		ErreurDriverLevel=WriteParPort(0xc0);	//clk off + data high 
	//	Sleep(1);
		temp=ReadParPort();
		in=in+(((temp/8)&0x01)<<k);				// input= error (8)
		ErreurDriverLevel=WriteParPort(0xe0);	//clk on + data high 
	//	Sleep(1);
	}
	return(in);

}

//*****************************************************************************
// Internal Function : lecture du conf register et vrif de la puce
// returns : value of the conf register
//*****************************************************************************
int  ReadConfReg(void)
{
	int in, temp, k;
	RstThermo();
	SendControlThermo(0xAC); //write conf reg

	ErreurDriverLevel=WriteParPort(0xC0);	//data high+rst high
	in=0;
	for (k=0;k<9;k++)
	{
		ErreurDriverLevel=WriteParPort(0xc0);	//clk off + data high 
	//	Sleep(1);
		temp=ReadParPort();
		in=in+(((temp/8)&0x01)<<k);				// input= error (8)
		ErreurDriverLevel=WriteParPort(0xe0);	//clk on + data high 
	//	Sleep(1);
	}
	return(in);

}